<template>
  <div v-if="editMode" :class="{ 'editable-composite-field': true, 'alted': isAltPressed }">
    <check-na :field="linkEditedData">
      <slot :link="linkEditedData || {}"></slot>
    </check-na>
    <!-- <a :href="urlLinkRawData" @click="false"><inline-editor v-model="textLinkRawData" :read-only="config.read_only"></inline-editor></a> -->
  </div>
  <div v-else-if="linkData">
    <router-link :to="{ path: linkData.url }"><slot :link="linkData || {}"></slot></router-link>
    <!-- <router-link :to="{ path: linkData.url }">{{ linkData.text }}</router-link> -->
    <!-- <check-na :field="linkData.text">{{ linkData.text }}</check-na> // <check-na :field="linkData.url">{{ linkData.url }}</check-na> -->
    <!-- <check-na :field="linkData"><slot :link="linkData"></slot></check-na> -->
    <!-- <check-na :field="linkData"><slot :link="linkData"></slot></check-na> -->
  </div>
  <div v-else>
    <slot></slot>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapActions, mapGetters } from 'vuex'

import InlineEditor from '@/components/Editable/Utils/InlineEditor'
import CheckNa from '@/components/Editable/Utils/CheckNa'

export default {
  components: {
    InlineEditor,
    CheckNa
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
  },

  data () {
    return {
      rawKey: 'inner-html'
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      editMode: 'Y3TI/editMode',
      getFieldConfig: 'Y3TI/getFieldConfig',
      isAltPressed: 'Y3TI/isAltPressed'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    // textLinkPlaceholder () {
    //   return _.get(this.config, 'widget.form.settings.placeholder_title')
    // },

    // urlLinkPlaceholder () {
    //   return _.get(this.config, 'widget.form.settings.placeholder_url')
    // },
    // displayAsHTML () {
    //   return _.get(this.config, 'options.display_as_html', false)
    // },

    // inputWithBr () {
    //   return _.get(this.config, 'options.input_with_br', false)
    // },

    linkData () {
      return _.get(this.node, this.path)
    },

    linkEditedData () {
      return this.getEditedField({ node: this.node, path: this.path, raw: this.rawKey })
    }
    // textLinkRawData: {
    //   get () {
    //     return this.getEditedField({ node: this.node, path: [...this.path, 'text'], raw: this.rawKey })
    //   },
    //   set (value) {
    //     this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'text'], input: value, raw: this.rawKey } })
    //   }
    // },

    // urlLinkRawData: {
    //   get () {
    //     return this.getEditedField({ node: this.node, path: [...this.path, 'url'], raw: this.rawKey })
    //   },
    //   set (value) {
    //     this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'url'], input: value, raw: this.rawKey } })
    //   }
    // }
  },

  methods: {
    ...mapActions({
      // storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    })
    // showPopupOptions (e) {
    //   if (true) {

    //   }
    //   console.log(e)
    //   window.alert('plafff')
    // }
    // updateText (e) {
    //   this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'text'], input: e.target.innerHTML } })
    // },

    // updateUrl (e) {
    //   this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, 'url'], input: e.target.innerHTML } })
    // }
  }
}
</script>

<style lang="scss" scoped>
</style>
